"use strict";
var core_1 = require('@angular/core');
var base_request_service_1 = require('./base-request.service');
var http_1 = require('@angular/http');
var BaseUserService = (function () {
    function BaseUserService() {
    }
    BaseUserService.init = function (config) {
        BaseUserService.config = config;
    };
    BaseUserService.getProfile = function (force) {
        var _this = this;
        if (force === void 0) { force = false; }
        if (!force && this.account && this.account.groups) {
            return new Promise(function (resolve, reject) {
                resolve(_this.account);
            });
        }
        var injector = core_1.ReflectiveInjector.resolveAndCreate([
            base_request_service_1.BaseRequestService, http_1.HTTP_PROVIDERS
        ]);
        var requestService = injector.get(base_request_service_1.BaseRequestService);
        return new Promise(function (resolve, reject) {
            requestService
                .get(BaseUserService.config.apiUrl.profile)
                .then(function (response) {
                _this.account = response;
                resolve(_this.account);
            }, function (error) {
                console.log(error);
                reject({});
            });
        });
    };
    BaseUserService.redirectLogin = function () { };
    BaseUserService.hasRole = function (role) {
        if (!this.account || !this.account.roles) {
            return false;
        }
        return this.account.roles.indexOf(role) !== -1;
    };
    BaseUserService.account = {};
    BaseUserService.config = {};
    return BaseUserService;
}());
exports.BaseUserService = BaseUserService;
//# sourceMappingURL=base-user.service.js.map